/* START Sample DESCRIPTION *********************************************

QSI_BasicCOMMSample.C

DESCRIPTION:	Sets up a basic communication protocol between the
					QSI and the BL2500.  Make sure the Sample program
               BasicCommSample.qly is running on the QSI LCD.

               The Inputs from the demo board will be sent every
               100 milli seconds to the QSI.  This consists of
               4 bytes, each byte representing the state of the
               inputs (byte 1 = input 1 state, 0 or 1, etc.)

               The outputs values are sent from the QSI to the
               SBC in the same order as the inputs.




END DESCRIPTION **********************************************************/

#use BL25xx.lib       			// sbc specific library

#define	EINBUFSIZE	31
#define	EOUTBUFSIZE	31
#define	BAUDRATE		19200		// Default on the QSI


char	SendData[EOUTBUFSIZE + 1]; // Tx data buffer
char	RecvData[EINBUFSIZE  + 1]; // Rx Data Buffer

// SendInputs();   reads the 4 inputs from the demo board and send
// it out the serial port.

int	SendInputs()
{
 	SendData[0] = digIn(0);
   SendData[1] = digIn(1);
   SendData[2]	= digIn(2);
   SendData[3] = digIn(3);
   serEwrite(SendData,4);
   return 1;
}

// Reads the serial port and sets the outputs accordingly.
// First byte read is the output number, second byte is the output state.
int	SetOutputs()
{
	serEread(RecvData,2,10);
	digOut(RecvData[0],RecvData[1]);
   return 1;

}


main ()
{
   brdInit();     // Initialize the SBC
   serEopen(BAUDRATE);  // Initialize the Commport
   serErdFlush();    // Flush the read buffer
   memset(SendData,0x00,sizeof(SendData));   // flush the TX,RX buffers
   memset(RecvData,0x00,sizeof(RecvData));
   for (;;)
   {
   	costate
      {
       	waitfor(DelayMs(100));   // waitfor 100 ms
         waitfor(SendInputs());   // Send the input status
      }
      costate
      {
       	waitfor(serErdUsed());    // waitfor a Reception

         waitfor(SetOutputs());    // Set the outputs
      }


   }



}